#ifndef __MIDILOAD_HPP__
#define __MIDILOAD_HPP__

#include "midicoll.hpp"

int midiload(const char* filename, EventInfoList& events, const char* eventmask = NULL, char preload = 0, const char* channels = 0);

class MidiLoadEvents : public MidiCollect
{
public:
  MidiLoadEvents(const char* filename, EventInfoList* events, const char* eventmask = NULL, char preload = 0);
  virtual ~MidiLoadEvents();

  void solochannel(int channel);

  char error_;
  unsigned long starttime_, endtime_;
  char channel_[16+1]; // 0 for events without channel

protected:
  virtual void StartEvents();
  virtual void Event(EventInfo* event);
  virtual void EndEvents();

  virtual int ignoreevent(EventInfo* event);

  EventInfoList* events_;

protected:
  long maxcount_;

  virtual void outofmemory();
  virtual void percent(int perc);
};

#endif
